from django.http import HttpResponse
from requests import Session
from requests.auth import HTTPBasicAuth  # or HTTPDigestAuth, or OAuth1, etc.
from zeep import Client
from zeep.transports import Transport
import mysql.connector
import hashlib
from cryptography.fernet import Fernet
#from mail import *
#from ping import *
import os
import bcrypt
import uuid
import datetime
import numpy as np
from django.shortcuts import render
from django.shortcuts import redirect
from django.template import RequestContext

mydb = mysql.connector.connect(
	host = "localhost",
	user = "Canopus",
	password = "care"
	

)

mycursor = mydb.cursor()


mycursor.execute("use care_new")


key = b'pRmgMa8T0INjEAfksaq2aafzoZXEuwKI7wDe4c1F8AY='

def masterdata():
	data = []
	command="SELECT sysname,sid,ostype,ipaddress,sitename,sitetype,siteaddress,customer_id,sysuniqueid from systems ;"
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	for i in myresult:
		cusnamecom = "SELECT cuscomname from customer_mang where cusuniqueid ='"+i[7]+"';" 
		mycursor.execute(cusnamecom)
		myresult = mycursor.fetchall()
		cusname = myresult[0][0]
		archdict = {
		"cusname":cusname,
		"sysname" : i[0],
		"sid": i[1],
		"ostype":i[2],
		"ip":i[3],
		"sitename":i[4],
		"sitetype":i[5],
		"siteaddress":i[6],
		"sysuniqueid" : i[8]
		}
		data.append(archdict)	
	return data

def home(request):
	return render(request,"index.html")

def login(request):
	return render(request,"login.html")

def land(request):
	return render(request,"arch.html")

def register(request):
	return render(request,"register.html")  

def forpass(request):
	return render(request,"forgotpass.html") 

def logout(request):
	return render(request,"login.html")

def add(request):
	if request.method == "POST":
			companyname = request.form['name']
			contactname = request.form['cname']
			email = request.form['email']
			mobile = request.form['mobile']
			pwd = request.form['pwd']
			address = request.form['add']
	hashAndSalt = bcrypt.hashpw(pwd.encode(), bcrypt.gensalt()) 
	cusuniqueid = uuid.uuid4() 
	created_at = datetime.datetime.now()
	modified_at = datetime.datetime.now()
	sub_by = email
	
	sql = "INSERT INTO customer_mang(cusuniqueid,cuscomname,cuscontactname,cusmobnum,cusaddress,cusemail,cuspassword,created_at,modified_at,sub_by) VALUES (%s, %s,%s, %s,%s, %s,%s,%s, %s,%s)"     
	value = (cusuniqueid.hex,companyname,contactname,mobile,address,email,hashAndSalt,created_at,modified_at,sub_by) 
	mycursor.execute(sql, value)
	mydb.commit()
	#mail(email)
	return render(request,"login.html")

def check_user(request):

		if request.method == "POST":
			form = request.POST.dict()
			email = form.get('username')
			pwd = form.get('pwd')

		
		command = "SELECT cuspassword from customer_mang where cusemail ='"+email+"';" 
		mycursor.execute(command)
		
		myresult = mycursor.fetchall()

		hashpw = myresult[0][0]
		print(hashpw)

		valid = bcrypt.checkpw(pwd.encode('utf8'), hashpw.encode('utf8'))
		if valid:
			request.session['email'] = email
			print(request.session['email'])
			response = redirect('/dash/')
			return response

def dash(request):
	if 'email' in request.session:
		return render(request,"metrics.html")
	else:
		response = redirect('/login/')
		return response
	

def architecture(request):
	if 'email' in request.session:
		email = request.session['email']
		if request.method == "POST":
				form = request.POST.dict()
				name = form.get('name')
				ip = form.get('ip')
				port = form.get('port')
				sid = form.get('sid')
				pwd = form.get('pwd')
				ty = form.get('ty')
				dbty = form.get('dbty')
				siname = form.get('siname')
				sity = form.get('sity')
				siincharge = form.get('siincharge')
				siadd = form.get('siadd')
		cipher_suite = Fernet(key)
		
		hashAndSalt = cipher_suite.encrypt(str.encode(pwd))
		sysuniqueid = uuid.uuid4() 
		created_at = datetime.datetime.now()
		modified_at = datetime.datetime.now()
		sub_by = email
		com_cusid = "SELECT cusuniqueid from customer_mang where cusemail='"+email+"';" 
		mycursor.execute(com_cusid)
		myresult = mycursor.fetchall()
		cusuniqueid = myresult[0][0]



		sql = "INSERT INTO systems(sysuniqueid,customer_id,sysname,sid,ostype,ipaddress,portnum,syspassword,sitename,sitetype,siteincharge,siteaddress,created_at,modified_at,sub_by,dbtype) VALUES(%s, %s,%s, %s,%s, %s,%s, %s,%s, %s, %s,%s, %s,%s, %s, %s)"     
		value = (sysuniqueid.hex,cusuniqueid,name,sid,ty,ip,port,hashAndSalt,siname,sity,siincharge,siadd,created_at,modified_at,sub_by,dbty)
		print(value)
		mycursor.execute(sql, value)
		mydb.commit()
		wsdl = 'http://' + ip + ':' + port + '/?wsdl'
		sywsdluniqueid = uuid.uuid4() 
		sqlwsdl = "INSERT INTO systemwsdl(sywsdluniqueid,customer_id,system_id,syswsdlurl,created_at,modified_at,sub_by) VALUES (%s, %s,%s, %s,%s, %s,%s)"
		valuewsdl = (sywsdluniqueid.hex,cusuniqueid,sysuniqueid.hex,wsdl,created_at,modified_at,sub_by)
		print(valuewsdl)
		mycursor.execute(sqlwsdl,valuewsdl)
		mydb.commit()
		# k = cipher_suite.decrypt(hashAndSalt)
		# print(k)
		return render(request,"metrics.html")
	else:
		response = redirect('/login/')
		return response

def ping(request):
	if request.method == "POST":
		ip = request.form['ip']
		output = os.system("ping -c 1 " + hostname)
		if output==0:
			response="Ping Successful"
			return JsonResponse({'output': response})
			
		else:
			response="Ping Unsuccessful"  
			return JsonResponse({'output': response})			


def monitoring(request):
	data=[]
	filterdata = []	
	data  = masterdata()

	if request.method == "GET":
		print('xcjv')
		filterdata = data

	elif request.method == "POST":
		print("dsjgj")
		a = []
		a = request.POST.getlist('sysids[]')
		
		if len(a)>1: 
			b = tuple(a)
			c = str(b)
		
			command="SELECT sysname,sid,ostype,ipaddress,sitename,sitetype,siteaddress,customer_id,sysuniqueid from systems where sysuniqueid in "+c+";"
			print(command)	
			mycursor.execute(command)
			myresult = mycursor.fetchall()
		elif len(a)==1:
			command="SELECT sysname,sid,ostype,ipaddress,sitename,sitetype,siteaddress,customer_id,sysuniqueid from systems where sysuniqueid = '"+a[0]+"';"
			print(command)	
			mycursor.execute(command)
			myresult = mycursor.fetchall()
						

		for i in myresult:
			cusnamecom = "SELECT cuscomname from customer_mang where cusuniqueid ='"+i[7]+"';" 
			mycursor.execute(cusnamecom)
			myresult = mycursor.fetchall()
			cusname = myresult[0][0]
			archdict = {
			"cusname":cusname,
			"sysname" : i[0],
			"sid": i[1],
			"ostype":i[2],
			"ip":i[3],
			"sitename":i[4],
			"sitetype":i[5],
			"siteaddress":i[6],
			"sysuniqueid" : i[8]
			}
			filterdata.append(archdict)

	context = {
		'data':data,
		'filterdata':filterdata,
	}
	return render(request,"viewland.html",context) 

def GetSystemInstanceList(request,name):
	command = "SELECT sysuniqueid,sid from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	print(sysuniqueid)
	data = []
	command1 = "SELECT * from instancelist where system_id='"+sysuniqueid+"';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	for i in myresult1:
		instdict = {
		"sysname":i[4],
		"sid":myresult[0][1],
		"http_port":i[6],
		"https_port":i[7],
		"features":i[10],
		"status":i[11]
		
		}
		data.append(instdict)
	context = {
		'data' : data,
		'name' : name,
	}			
	return render(request,"instancelist.html",context)				

def GetProcessList(request,name):
	command = "SELECT sysuniqueid,sid,sysname from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	print(sysuniqueid)
	data = []
	command1 = "SELECT pname,pdesc,dispstatus,TIMESTAMPDIFF(HOUR,stime,CURRENT_TIMESTAMP()) as t from process_list where system_id='"+sysuniqueid+"';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	for i in myresult1:
		instdict = {
		"sysname":myresult[0][2],
		"sid":myresult[0][1],
		"pname":i[0],
		"pdesc":i[1],
		"dispstatus":i[2],
		"ElapsedTime":i[3]
		
		}
		data.append(instdict)
	context = {
		'data' : data,
		'name' : name,
	}			
	return render(request,"processlist.html",context) 	

def FSUsage(request,name):
	command = "SELECT sysuniqueid,sid,sysname from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	#print(sysuniqueid)
	data = []
	command1 = "SELECT * from fsmetircs where system_id='"+sysuniqueid+"';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	for i in myresult1:
		instdict = {
		"sysname":myresult[0][2],
		"sid":myresult[0][1],
		"filesys":i[4],
		"size":i[5],
		"used":i[6],
		"available":i[7],
		"perc":i[8],
		"Mounted_On":i[9] 
		
		}
		data.append(instdict)
	context = {
		'name' : name,
		'data' : data,
	}			
	return render(request,"fsusage.html",context)	

def memory(request,name):
	command = "SELECT sysuniqueid,sid,sysname from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	mem = []
	command1 = "SELECT * from memorymetrics where system_id='"+sysuniqueid+"' and memtype = 'Mem';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	
	for i in myresult1:
		
		memdict = {
		"sysname" : myresult[0][2],
		"sid" : myresult[0][1],
		"port" : i[11],
		"total" : i[5],
		"used" : i[6],
		"free" : i[7],
		"shared" : i[8],
		"cache" : i[9],
		"available" : i[10],
		}
		mem.append(memdict)
	
	context = {
		'mem' : mem,
		'name' : name,
	}	
	return render(request,"memory.html",context)

def swap(request,name):
	command = "SELECT sysuniqueid,sid,sysname from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	swap = []
	command1 = "SELECT * from memorymetrics where system_id='"+sysuniqueid+"' and memtype = 'Swap';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	
	for i in myresult1:
		
		memdict = {
		"sysname" : myresult[0][2],
		"sid" : myresult[0][1],
		"port" : i[11],
		"total" : i[5],
		"used" : i[6],
		"free" : i[7],
		"shared" : i[8],
		"cache" : i[9],
		"available" : i[10],
		}
		swap.append(memdict)
	context = {
		'swap' : swap,
		'name' : name,
	}	

	return render(request,"Swap.html",context)

def cpuutil(request,name):
	command = "SELECT sysuniqueid,sid,sysname from systems where sysname ='"+name+"';" 
	mycursor.execute(command)
	myresult = mycursor.fetchall()
	sysuniqueid = myresult[0][0]
	cpu = []
	command1 = "SELECT * from cpumetrics where system_id='"+sysuniqueid+"';"
	mycursor.execute(command1)
	myresult1 = mycursor.fetchall()
	
	for i in myresult1:
	
		memdict = {
		"sysname" : myresult[0][2],
		"sid" : myresult[0][1],
		'User' : i[4],
		'Nice':i[-1],
		'System':i[5],
		'IOWait':i[6],
		'Steal':i[7],
		'IDLE':i[8]
		}
		cpu.append(memdict)
	context = {
		'cpu' : cpu,
		'name' : name,
	}
	return render(request,"cpu.html",context)
